package cmd

import (
	"framework_v2/internal/providers"
	"framework_v2/internal/providers/jwks"
	"framework_v2/internal/routes"
	"github.com/gin-gonic/gin"
	"github.com/spf13/cobra"
)

var httpCommand = &cobra.Command{
	Use: "http",

	Run: func(cmd *cobra.Command, args []string) {
		jwks.InitJwksRefresh()

		StartHttp()
	},
}

func StartHttp() {
	if config.ListenAddr.HTTP == "" {
		config.ListenAddr.HTTP = "0.0.0.0:8080"
	}

	routes.InitApiRoutes()
	router := providers.MustGet[gin.Engine]()
	logger.Info("Http Server listening at " + config.ListenAddr.HTTP)
	err := router.Run(config.ListenAddr.HTTP)
	if err != nil {
		panic("failed to listen: " + err.Error())
	}
}
